<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabecComprasStatusERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabecComprasStatusERP
 * @subpackage Arrays
 */
class ArrayOfCabecComprasStatusERP extends AbstractStructArrayBase
{
    /**
     * The CabecComprasStatusERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabecComprasStatusERP[]
     */
    public $CabecComprasStatusERP;
    /**
     * Constructor method for ArrayOfCabecComprasStatusERP
     * @uses ArrayOfCabecComprasStatusERP::setCabecComprasStatusERP()
     * @param \StructType\CabecComprasStatusERP[] $cabecComprasStatusERP
     */
    public function __construct(array $cabecComprasStatusERP = array())
    {
        $this
            ->setCabecComprasStatusERP($cabecComprasStatusERP);
    }
    /**
     * Get CabecComprasStatusERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabecComprasStatusERP[]|null
     */
    public function getCabecComprasStatusERP()
    {
        return isset($this->CabecComprasStatusERP) ? $this->CabecComprasStatusERP : null;
    }
    /**
     * Set CabecComprasStatusERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabecComprasStatusERP[] $cabecComprasStatusERP
     * @return \ArrayType\ArrayOfCabecComprasStatusERP
     */
    public function setCabecComprasStatusERP(array $cabecComprasStatusERP = array())
    {
        foreach ($cabecComprasStatusERP as $arrayOfCabecComprasStatusERPCabecComprasStatusERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabecComprasStatusERPCabecComprasStatusERPItem instanceof \StructType\CabecComprasStatusERP) {
                throw new \InvalidArgumentException(sprintf('The CabecComprasStatusERP property can only contain items of \StructType\CabecComprasStatusERP, "%s" given', is_object($arrayOfCabecComprasStatusERPCabecComprasStatusERPItem) ? get_class($arrayOfCabecComprasStatusERPCabecComprasStatusERPItem) : gettype($arrayOfCabecComprasStatusERPCabecComprasStatusERPItem)), __LINE__);
            }
        }
        if (is_null($cabecComprasStatusERP) || (is_array($cabecComprasStatusERP) && empty($cabecComprasStatusERP))) {
            unset($this->CabecComprasStatusERP);
        } else {
            $this->CabecComprasStatusERP = $cabecComprasStatusERP;
        }
        return $this;
    }
    /**
     * Add item to CabecComprasStatusERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CabecComprasStatusERP $item
     * @return \ArrayType\ArrayOfCabecComprasStatusERP
     */
    public function addToCabecComprasStatusERP(\StructType\CabecComprasStatusERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabecComprasStatusERP) {
            throw new \InvalidArgumentException(sprintf('The CabecComprasStatusERP property can only contain items of \StructType\CabecComprasStatusERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabecComprasStatusERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabecComprasStatusERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabecComprasStatusERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabecComprasStatusERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabecComprasStatusERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabecComprasStatusERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabecComprasStatusERP
     */
    public function getAttributeName()
    {
        return 'CabecComprasStatusERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabecComprasStatusERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
